<template>
  <el-dialog
    append-to-body
    custom-class="center-dialog"
    :title="title"
    top="0vh"
    :visible.sync="dialogFormVisible"
    width="500px"
    @close="close"
  >
    <el-form ref="form" label-width="80px" :model="form" :rules="rules">
      <el-form-item :label="__('部门名称')" prop="department_name">
        <el-input
          v-model="form.department_name"
          :placeholder="__('部门名称')"
        />
      </el-form-item>
      <el-form-item :label="__('部门名称')" prop="department_name">
        <el-radio v-model="form.department_enable" :label="1">
          {{ __('启动') }}
        </el-radio>
        <el-radio v-model="form.department_enable" :label="0">
          {{ __('禁用') }}
        </el-radio>
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button @click="close">{{ __('取消') }}</el-button>
      <el-button type="primary" @click="save">{{ __('确定') }}</el-button>
    </div>
  </el-dialog>
</template>

<script>
  import { translateTitle as __ } from '@/utils/i18n'

  import { doEdit } from '@/api/store/employee/department'

  export default {
    name: 'StoreEmployeeDepartmentEdit',
    data() {
      return {
        form: {},
        rules: {},
        title: '',
        dialogFormVisible: false,
      }
    },
    created() {},
    mounted() {
      this.form = {
        unit_name: '',
      }

      this.rules = {
        department_id: [
          { required: true, trigger: 'blur', message: this.__('部门编号') },
        ],
        department_parent_id: [
          { required: true, trigger: 'blur', message: this.__('上级部门') },
        ],
        department_name: [
          { required: true, trigger: 'blur', message: this.__('权限组名称') },
        ],
        department_add_time: [
          { required: true, trigger: 'blur', message: this.__('创建时间') },
        ],
        store_id: [
          { required: true, trigger: 'blur', message: this.__('店铺编号') },
        ],
        department_enable: [
          { required: true, trigger: 'blur', message: this.__('是否启用') },
        ],
        department_buildin: [
          { required: true, trigger: 'blur', message: this.__('系统内置') },
        ],
      }

      this.$forceUpdate()
    },
    methods: {
      __,
      showEdit(row) {
        if (!row.department_id) {
          this.form.department_parent_id = row
          this.title = this.__('添加')
        } else {
          this.title = this.__('编辑')
          this.form = {
            department_id: row.department_id,
            department_name: row.department_name,
            department_enable: row.department_enable,
          }
        }
        this.dialogFormVisible = true
      },
      close() {
        this.form = this.$options.data().form
        this.$refs['form'].resetFields()
        this.dialogFormVisible = false
      },
      save() {
        this.$refs['form'].validate(async (valid) => {
          if (valid) {
            const { msg, status } = await doEdit(this.form)
            if (200 == status) {
              this.$baseMessage(msg, 'success')
            } else {
              this.$baseMessage(msg, 'error')
            }
            this.$emit('fetch-data')
            this.close()
          } else {
            return false
          }
        })
      },
    },
  }
</script>
